## Общая структура

```
    ┌───────────────────────────┐
    │                           │
    │         SPI flash         │
    │                           │
    └─────────────▴─────────────┘
                  │
    ┌─────────────┴─────────────┐
    │                           │
    │ Драйвер носителя (devf-*) │
    │                           │
    └─────────────▴─────────────┘
                  │
    ┌─────────────┴─────────────┐
    │                           │
    │   Клиентское приложение   │
    │                           │
    └───────────────────────────┘
```



## Дерево исходных кодов

```
|- flash/
|  |- spi-s25/          - Исходный код flash-драйвера для устройств на базе 1890ВМ108
|  |- Makefile          - Правила сборки дерева исходников
|  `- common.mk         - Параметры сборки драйверов
|
`- Makefile             - Правила сборки дерева исходников
```



## Сборка драйвера

- Установить и настроить [комплект разработчика](https://help.kpda.ru/neutrino/2020/help/topic/ru.kpda.doc.dev_tools_ru/html/devkit/devkit.html) для [ЗОСРВ "Нейтрино" редакции 2020](https://help.kpda.ru/neutrino/2020/help/index.jsp).
- Выполнить команду:

```
make
```



## Запуск драйвера

```
devf-spi-s25 -s0,0 &
```
