/*
 * (c) 2021, SWD Embedded Systems Limited, http://www.kpda.ru
 */


#ifndef __FSLSPI_H_INCLUDED
#define __FSLSPI_H_INCLUDED


#include <sys/mman.h>
#include <sys/f3s_mtd.h>
#include <sys/neutrino.h>
#include <libc.h>
#include <hw/inout.h>

#include "s25-spi.h"


/* Freescale SPI Function Prototypes and Constant Definitions */
_int32 f3s_spi_ident( f3s_dbase_t *dbase, f3s_access_t *access, _uint32 flags, _uint32 offset );
void f3s_spi_reset( f3s_dbase_t *dbase, f3s_access_t *access, _uint32 flags, _uint32 offset );
int32_t f3s_spi_v2read( f3s_dbase_t *dbase, f3s_access_t *access, uint32_t flags, uint32_t offset, int32_t size, uint8_t *buffer );
_int32 f3s_spi_v2write( f3s_dbase_t *dbase, f3s_access_t *access, _uint32 flags, _uint32 offset, _int32 size, _uint8 *buffer );
int f3s_spi_v2erase( f3s_dbase_t *dbase, f3s_access_t *access, _uint32 flags, _uint32 offset );
int f3s_spi_v2sync( f3s_dbase_t *dbase, f3s_access_t *access, _uint32 flags, _uint32 offset );
int f3s_spi_v2islock( f3s_dbase_t *dbase, f3s_access_t *access, _uint32 flags, _uint32 offset );
int f3s_spi_v2lock( f3s_dbase_t *dbase, f3s_access_t *access, _uint32 flags, _uint32 offset );
int f3s_spi_v2unlock( f3s_dbase_t *dbase, f3s_access_t *access, _uint32 flags, _uint32 offset );
int f3s_spi_v2unlockall( f3s_dbase_t *dbase, f3s_access_t *access, _uint32 flags, _uint32 offset );
int32_t f3s_spi_open( f3s_socket_t *socket, uint32_t flags );
uint8_t * f3s_spi_page( f3s_socket_t *socket, uint32_t page, uint32_t offset, int32_t *size );
int32_t generic_status( f3s_socket_t *socket, uint32_t flags );
void f3s_spi_close( f3s_socket_t *socket, uint32_t flags );


#endif  /* __FSLSPI_H_INCLUDED */
