/*
 * (c) 2021, SWD Embedded Systems Limited, http://www.kpda.ru
 */


#include <sys/f3s_mtd.h>
#include <pthread.h>
#include "f3s_spi.h"


int32_t f3s_spi_ident( f3s_dbase_t *dbase, f3s_access_t *access, uint32_t flags, uint32_t offset )
{
    /* setup database with proper info */

    /* Fill dbase entry */
    dbase->struct_size = sizeof( *dbase );
    dbase->jedec_hi    = 0x0120;
    dbase->jedec_lo    = 0x184d;
    dbase->name        = "SPI M25";
    dbase->buffer_size = PAGE_SIZE;     /* buffer size information */
    dbase->geo_num     = 1;             /* Read number of geometries */
    if ( verbose > 3 )
        printf( "(devf  t%d::%s:%d) dbase->geo_num = %d\n", pthread_self(), __func__, __LINE__, dbase->geo_num );

    dbase->geo_vect[0].unit_num  = NUM_ERASE_UNITS;
    dbase->geo_vect[0].unit_pow2 = PWR2_SIZE_UNIT;
    if (verbose > 3)
    {
        printf( "(devf  t%d::%s:%d) dbase->geo_vect[%d].unit_pow2 = %d\n", pthread_self(), __func__, __LINE__,
                0, dbase->geo_vect[0].unit_pow2 );
        printf( "(devf  t%d::%s:%d) dbase->geo_vect[%d].unit_num  = %d\n", pthread_self(), __func__, __LINE__,
                0, dbase->geo_vect[0].unit_num );
    }

    /* Set bus and chip parameters */
    dbase->chip_inter = flashcfg.chip_inter;
    dbase->chip_width = flashcfg.bus_width;

    /* Set capabilities flags */
    /*dbase->flags = F3S_ERASE_FOR_ALL;*/

    return (EOK);
}
