/*
 * (c) 2021, SWD Embedded Systems Limited, http://www.kpda.ru
 */


#include "f3s_spi.h"


uint8_t * f3s_spi_page( f3s_socket_t *socket, uint32_t flags, uint32_t offset, int32_t *size )
{
    /* check if offset does not fit in array */
    if ( offset >= socket->window_size )
    {
        errno = ERANGE;
        return (NULL);
    }

    /* always zero since there is only 1 window for this device */
    socket->window_offset = 0;

    /* ensure that offset + size is not out of bounds */
    if ( size )
        *size = min( *size, socket->window_size - offset );

    /* memory pointers are not applicable to this device so we just return ~NULL every time the offset is within bounds */
    return (uint8_t *)~((uintptr_t)NULL);
}
